// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.0.0
// @generated from file google/api/expr/v1alpha1/eval.proto (package google.api.expr.v1alpha1, syntax proto3)
/* eslint-disable */
// @ts-nocheck

import { proto3 } from "@bufbuild/protobuf";
import { Value } from "./value_pb.js";
import { Status } from "../../../rpc/status_pb.js";

/**
 * The state of an evaluation.
 *
 * Can represent an inital, partial, or completed state of evaluation.
 *
 * @generated from message google.api.expr.v1alpha1.EvalState
 */
export const EvalState = proto3.makeMessageType(
  "google.api.expr.v1alpha1.EvalState",
  () => [
    { no: 1, name: "values", kind: "message", T: ExprValue, repeated: true },
    { no: 3, name: "results", kind: "message", T: EvalState_Result, repeated: true },
  ],
);

/**
 * A single evalution result.
 *
 * @generated from message google.api.expr.v1alpha1.EvalState.Result
 */
export const EvalState_Result = proto3.makeMessageType(
  "google.api.expr.v1alpha1.EvalState.Result",
  () => [
    { no: 1, name: "expr", kind: "scalar", T: 3 /* ScalarType.INT64 */ },
    { no: 2, name: "value", kind: "scalar", T: 3 /* ScalarType.INT64 */ },
  ],
  {localName: "EvalState_Result"},
);

/**
 * The value of an evaluated expression.
 *
 * @generated from message google.api.expr.v1alpha1.ExprValue
 */
export const ExprValue = proto3.makeMessageType(
  "google.api.expr.v1alpha1.ExprValue",
  () => [
    { no: 1, name: "value", kind: "message", T: Value, oneof: "kind" },
    { no: 2, name: "error", kind: "message", T: ErrorSet, oneof: "kind" },
    { no: 3, name: "unknown", kind: "message", T: UnknownSet, oneof: "kind" },
  ],
);

/**
 * A set of errors.
 *
 * The errors included depend on the context. See `ExprValue.error`.
 *
 * @generated from message google.api.expr.v1alpha1.ErrorSet
 */
export const ErrorSet = proto3.makeMessageType(
  "google.api.expr.v1alpha1.ErrorSet",
  () => [
    { no: 1, name: "errors", kind: "message", T: Status, repeated: true },
  ],
);

/**
 * A set of expressions for which the value is unknown.
 *
 * The unknowns included depend on the context. See `ExprValue.unknown`.
 *
 * @generated from message google.api.expr.v1alpha1.UnknownSet
 */
export const UnknownSet = proto3.makeMessageType(
  "google.api.expr.v1alpha1.UnknownSet",
  () => [
    { no: 1, name: "exprs", kind: "scalar", T: 3 /* ScalarType.INT64 */, repeated: true },
  ],
);

